#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>

#include "Stream.h"
#include "Client.h"

Client client;

void interruptHandler(int signal)
{
    clientRemove(&client);
    exit(EXIT_SUCCESS);
}

int main(int argc, char **argv)
{
    if(argc < 2)
    {
        printf("Usage: %s server_address\n", argv[0]);
        return EXIT_FAILURE;
    }
    
    clientInitDefaults(&client);
    
    signal(SIGINT, interruptHandler);
    signal(SIGKILL, interruptHandler);
    
    if(clientInit(&client, argv[1], 6543) == -1)
    {
        return EXIT_FAILURE;
    }

    clientWaitForData(&client);

    clientRemove(&client);
    return EXIT_SUCCESS;
}
